{% extends "base.html" %}
{% load static %}
{% load article %}
{% load markdown_extras %}

{% block stylesheet %}
    <link rel="stylesheet" href="{% static 'css/couleurs_demande_article.css' %}">
    <!-- CSS pour datetime picker -->
    <link rel="stylesheet" href="{% static 'js/jquery.datetimepicker.min.css' %}">

    <!-- CSS pour autocomplete_light -->
    <link rel="stylesheet" href="{% static 'select2/css/select2.css' %}">
    <link rel="stylesheet" href="{% static 'autocomplete_light/select2.css' %}">

    <!-- Bordure des tables -->
    <link rel="stylesheet" href="{% static 'css/table.css' %}">
{% endblock  %}


{% block javascript %}
    {# a employer dans les templates fils->{{ block.super }} #}
    {{ block.super }}

    <!-- datetime picker jQuery script -->
    <script src="{% static 'js/jquery.datetimepicker.full.js' %}"></script>

    <!-- Javascript for autocomplete_light -->
    <script src="{% static 'autocomplete_light/jquery.init.js' %}"></script>
    <script src="{% static 'autocomplete_light/autocomplete.init.js' %}"></script>
    <script src="{% static 'select2/js/select2.full.js' %}"></script>
    <script src="{% static 'autocomplete_light/forward.js' %}"></script>
    <script src="{% static 'autocomplete_light/select2.js' %}"></script>

    <script type="module">
        import { increment_update, build_url_with_parameters, update_demande } from '{% static 'js/utils.js' %}';
        import { update_iframe_description_demande, update_summernote, id3_fetch } from '{% static 'js/utils.js' %}';

        window.increment_update = increment_update;
        window.build_url_with_parameters = build_url_with_parameters;
        window.update_demande = update_demande;
        window.update_iframe_description_demande = update_iframe_description_demande;
        window.update_summernote = update_summernote;
        window.id3_fetch = id3_fetch;
    </script>

{% endblock javascript %}

{% block extra_js %}
{# Code composé de Javascript et de Django Template Language #}
{# ========================================================= #}

<script type="module">

function trt_date_butoir() {
    // langue française
    $.datetimepicker.setLocale('fr');

    {% for form_codif_article in formset_codif_articles %}
        {# Choix de la livraison souhaitée #}
        $('#id_codifarticle_related-{{ forloop.counter0 }}-date_butoir').datetimepicker(
            {
                // http://marcocecchetti.it/Post/Articolo/608
                weeks: true,
                rtl: false,
                // formatTime:'H:i',
                // formatDate:'d/m/Y',
                format: 'd/m/Y H:i',
                // date
                datepicker: true,
                opened: false,
                todayButton: true,     // Show button "Go To Today"
                defaultSelect:  true,  // Highlight the current date even if the input is empty
                dayOfWeekStart : 1, // Start week DatePicker. Default Sunday=0.
                defaultDate: false,
                // https://secure.php.net/manual/fr/function.date.php
                minDate:0,    // today
                weekends : [],
                disabledDates : [],
                // time
                timepicker:true,
                timepickerScrollbar:true,
                step: 60,
                defaultTime:'10:00',
                allowTimes:[
                  '8:00', '9:00', '10:00', '11:00', '12:00',
                  '13:00', '14:00', '15:00', '16:00', '17:00',
                  '18:00', '19:00'
                ]
            }
        );

    {% endfor %}

}

document.addEventListener('DOMContentLoaded', (event) => {
    // https://gdevops.frama.io/web/linkertree/html/apis/document/events/DOMContentLoaded_event/DOMContentLoaded_event.html
    console.log('DOM is loaded');
    console.log(`document.readyState = ${document.readyState}`);

    trt_date_butoir();
});

function trt_widgets() {
    console.log(`trt_widgets() document.readyState = ${document.readyState}`);
    document.getElementById('id_etat_demande').onchange = function() {
        const url = '{% url "articles:ajax_update_demande_article" %}';
        update_demande(url);
    }
    const url = '{% url "articles:ajax_update_codif_article" %}';
    let codifarticle_id = 0;
    {% for form_codif_article in formset_codif_articles %}
        codifarticle_id = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-id').value;
        const parameters_{{ forloop.counter0 }} = {'id': codifarticle_id};
        try {
            document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-etat_poste').onchange = function() {
                parameters_{{ forloop.counter0 }}.etat_poste = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-etat_poste').value;
                id3_fetch(url, parameters_{{ forloop.counter0 }});
            }
        } catch (error) {
            ;
        }
        try {
            document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-ofda').onchange = function() {
                parameters_{{ forloop.counter0 }}.ofda = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-ofda').value;
                id3_fetch(url, parameters_{{ forloop.counter0 }});
            }
        } catch (error) {
            ;
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-article').onchange = function() {
            parameters_{{ forloop.counter0 }}.article_id =document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-article').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }}).then(json => { document.getElementById('libelle_article_{{ forloop.counter0 }}').textContent = json.libelle_article;});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-projet').onchange = function() {
            parameters_{{ forloop.counter0 }}.projet_id = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-projet').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }}).then(json => { document.getElementById('libelle_projet_{{ forloop.counter0 }}').textContent = json.libelle_projet});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-fabricant').onchange = function() {
            parameters_{{ forloop.counter0 }}.fabricant_id = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-fabricant').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});            ;
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-ref_fabricant').onchange = function() {
            parameters_{{ forloop.counter0 }}.ref_fabricant = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-ref_fabricant').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-fournisseur').onchange = function() {
            parameters_{{ forloop.counter0 }}.fournisseur_id = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-fournisseur').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-ref_fournisseur').onchange = function() {
            parameters_{{ forloop.counter0 }}.ref_fournisseur = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-ref_fournisseur').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-date_butoir').onchange = function() {
            parameters_{{ forloop.counter0 }}.date_butoir = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-date_butoir').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-demande_codification').onchange = function() {
            parameters_{{ forloop.counter0 }}.demande_codification = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-demande_codification').checked;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-besoin_reel').onchange = function() {
            parameters_{{ forloop.counter0 }}.besoin_reel = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-besoin_reel').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-besoin_potentiel').onchange = function() {
            parameters_{{ forloop.counter0 }}.besoin_potentiel = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-besoin_potentiel').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-sortie_stock').onchange = function() {
            parameters_{{ forloop.counter0 }}.sortie_stock = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-sortie_stock').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }
        document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-cotation_par').onchange = function() {
            parameters_{{ forloop.counter0 }}.cotation_par = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-cotation_par').value;
            id3_fetch(url, parameters_{{ forloop.counter0 }});
        }

    {% endfor %}
}


function trt_iframe_description_demande()
{
    console.log(`trt_description_demande() document.readyState = ${document.readyState}`);

    const url = '{% url "articles:ajax_update_demande_article" %}';
    const iframe_description_demande = document.getElementById('id_description_iframe');
    iframe_description_demande.contentDocument.activeElement.onblur = function() {
        try {
            let libelles_description = [];
            let libelle_description = "";
            {% for form_codif_article in formset_codif_articles %}
                {% if forloop.counter >= 2 %}
                    libelle_description = document.getElementById('libelle_description_{{ forloop.counter0 }}');
                    libelles_description.push(libelle_description);
                {% endif %}
            {% endfor %}
            update_iframe_description_demande(url, libelles_description);
        } catch (error) {
            console.error(error);
        }
    }
}


function trt_iframes_responses()
{
    console.log(`trt_iframes_reponses() document.readyState = ${document.readyState}`);
    const url = '{% url "articles:ajax_update_codif_article" %}';
    {% for form_codif_article in formset_codif_articles %}
        try
        {
            {# le champ reponse n'est pas toujours present #}
            const iframe_reponse_{{ forloop.counter0 }} = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-reponse_iframe');
            iframe_reponse_{{ forloop.counter0 }}.contentDocument.activeElement.onblur = function() {
                const editables = iframe_reponse_{{ forloop.counter0 }}.contentDocument.getElementsByClassName('note-editable');
                const codifarticle_id = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-id').value;
                const map_parameters = new Map([['id',codifarticle_id],['reponse', ""]]);
                update_summernote(url, editables, map_parameters, 'reponse');
            }
        } catch (error) {
            ; // console.error(error);
        }

    {% endfor %}
}

function trt_iframes_designations()
{
    console.log(`trt_iframes_designations() document.readyState = ${document.readyState}`);

    const url = '{% url "articles:ajax_update_codif_article" %}';
    {% for form_codif_article in formset_codif_articles %}
        const iframe_designation_{{ forloop.counter0 }} = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-designation_iframe');
        iframe_designation_{{ forloop.counter0 }}.contentDocument.activeElement.onblur = function() {
            const editables = iframe_designation_{{ forloop.counter0 }}.contentDocument.getElementsByClassName('note-editable');
            const codifarticle_id = document.getElementById('id_codifarticle_related-{{ forloop.counter0 }}-id').value;
            const map_parameters = new Map([['id',codifarticle_id],['designation', ""]]);
            update_summernote(url, editables, map_parameters, 'designation');
       }
    {% endfor %}
}

window.addEventListener('load', (event) => {
    console.log('window page is fully loaded');

    {% comment %}
    On ne traite les iframes que lorsque tout est chargé
    voir:
    - https://javascript.info/onload-ondomcontentloaded#readystate
    - https://developer.mozilla.org/en-US/docs/Web/API/Window/load_event
    {% endcomment %}

    trt_widgets();
    trt_iframe_description_demande();
    trt_iframes_responses();
    trt_iframes_designations();
});



</script>
{% endblock extra_js %}


{% block content %}


<a class="btn btn-success" href="{% url 'articles:demande_article_non_cloturee_list' %}">Liste des demandes non clôturées</a>
<a class="btn btn-success" href="{% url 'articles:demande_article_list' %}">Liste de toutes les demandes</a>


{% url 'articles:demande_codif_article_update' demande_article.pk  as url_demande_codif_article_update %}


{# https://getbootstrap.com/components/#labels #}

{% if demande_article.demande_non_transmise %}
<h4 class="couleur_demande_non_transmise">
{% elif demande_article.demande_transmise %}
<h4 class="couleur_demande_transmise">
{% elif demande_article.demande_en_cours %}
<h4 class="couleur_demande_en_cours">
{% elif demande_article.demande_traitee %}
<h4 class="couleur_demande_traitee">
{% elif demande_article.demande_cloturee %}
<h4 class="couleur_demande_cloturee">
{% endif %}
    Demande N° <span id="id_demande_article"> {{ demande_article.id }}</span> Update:<span id="id_nb_ajax_call"> 0</span>
</h4>


{% if messages %}
    <ul class="messages">
        {% comment %} https://getbootstrap.com/components/#alerts {% endcomment %}
        {% for message in messages %}
        <!--li{% if message.tags %} class="{{ message.tags }}"{% endif %} -->
            {% if message.level == DEFAULT_MESSAGE_LEVELS.ERROR %}
                <div class="alert alert-danger" role="alert">{{ message }}</div>
            {% elif message.level == DEFAULT_MESSAGE_LEVELS.SUCCESS %}
                <div class="alert alert-success" role="alert">{{ message }}</div>
            {% else %}
                <div class="alert alert-info" role="alert">{{ message }}</div>
            {% endif %}
        <!-- /li -->
        {% endfor %}
    </ul>
{% endif %}

{{ form.description }}
{{ form.etat_demande }}
<tr>
    <th><label for="id_send_email">Envoi courriel :</label></th>
    <td><input type="checkbox" name="send_email" id="id_send_email"></td>
</tr>

{% url 'tiers:create'  as url_tiers_create %}

<form id="codif_articles" method="post" action=".">
    {% csrf_token %}
    <input type="hidden" name="demande_article" value="{{ demande_article }}">
    <div class="table-responsive">
        <table id="id_list_table" class="table table-condensed">
            <tbody>
                {{ formset_codif_articles.management_form }}
                {# rajout des erreurs #}
                {% if formset_codif_articles.errors %}
                    {% for error in formset_codif_articles.non_field_errors %}
                        <div class="alert alert-error">
                            <strong>{{ error|escape }}</strong>
                        </div>
                    {% endfor %}
                {% endif %}
                {# Parcours des formulaires et des instances initiales associées #}
                {% for form_codif_article, codif_article in formset_instances %}
                    {{ form_codif_article.id }}
                    <tr>
                       <td>
                           <table id="id_table_in_table" class="table table-hover table-bordered table-condensed
                                {% if forloop.counter|divisibleby:"2" %}
                                   table-pair
                                {% else %}
                                    table-impair
                                {% endif %}
                                ">
                               {# un element de formulaire => un tableau dans un tableau #}
                                <tbody>
                                    <tr>
                                       {% url 'articles:codif_article_delete' form_codif_article.id.value  as url_codif_article_delete %}
                                       {% url 'articles:codif_article_clone'  form_codif_article.id.value  as url_codif_article_clone %}
                                       {% if forloop.counter <= nb_articles %}
                                            <td colspan=2 id={{ forloop.counter }}>
                                               {% comment %}
                                                   Mise en place des liens internes à une page HTML (href)
                                                   https://www.w3schools.com/tags/tryit.asp?filename=tryhtml5_a_href_anchor
                                               {% endcomment %}
                                               {% for num_article in list_articles %}
                                                  {% if num_article != forloop.parentloop.counter  %}
                                                      <a href="#{{ num_article }}">Codif {{ num_article }}</a>
                                                  {% else %}
                                                      Codif  {{ forloop.parentloop.counter }} N°{{codif_article.id }}
                                                  {% endif %}
                                               {% endfor %}
                                               {% if demande_article.demande_non_cloturee %}
                                                   <a href="{{ url_codif_article_clone }}"> | Ajouter un article</a>
                                                   <a href="{{ url_codif_article_delete }}">| Supprimer un article</a>
                                                   {% if forloop.counter >= 2 %}
                                                       <ul class=list-group>
                                                          <li class="alert alert-success list-group-item">
                                                            <a href="#id_demande_article">Demande article N°{{ demande_article.id }}</a>
                                                             <span id="libelle_description_{{ forloop.counter0 }}"> {{ demande_article.description | markdown | safe }}</span>
                                                          </li>
                                                       </ul>
                                                   {% endif %}
                                               {% endif %}
                                            </td>
                                        {% else %}
                                            <td colspan=2>
                                            </td>
                                        {% endif %}
                                    </tr>
                                    {% if demande_article.reponse_affichable %}
                                        <tr>
                                            {% comment %} Affichage en vert quand l'état du poste est dans l'état "Traité" {% endcomment %}
                                            <td {% if codif_article.is_poste_traite %} class="text-right poste_traite" {% else %} class="text-right" {% endif %}>
                                                Etat du poste {{ form_codif_article.etat_poste }}
                                            </td>
                                            <td {% if codif_article.is_poste_traite %} {% else %} class="info" {% endif %}>
                                                Réponse {{ form_codif_article.reponse }}
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="text-right">N°OFDA</td>
                                            <td class="info">{{ form_codif_article.ofda }}
                                            </td>
                                        </tr>
                                    {% endif %}
                                    <tr>
                                        <td class="text-right">Code article</td>
                                        <td class="danger">
                                            {% if demande_article.demande_non_cloturee %}
                                                {{ form_codif_article.article }}
                                            {% endif %}
                                            <span id="libelle_article_{{ forloop.counter0 }}"> {{ codif_article.get_libelle_article }}</span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Projet</td>
                                        <td>
                                            {% if demande_article.demande_non_cloturee %}
                                                {{ form_codif_article.projet }}
                                            {% endif %}
                                            <span id="libelle_projet_{{ forloop.counter0 }}"> {{ codif_article.get_libelle_projet }}</span>
                                       </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Désignation</td>
                                        <td>{{ form_codif_article.designation }}</td>
                                    </tr>
                                    {% if codif_article.demande_cloturee_and_no_documents %}
                                    {% else %}
                                        <tr>
                                            {% url 'articles:codif_article_doc_list'  codif_article.id  as url_list_documents %}
                                            <td class="text-right">
                                                {% if demande_article.demande_non_cloturee %}
                                                    {% if forloop.counter <= nb_articles %}
                                                        <a href="{{ url_list_documents }}">Documents associés</a>
                                                    {% endif %}
                                                {% else %}
                                                    Documents associés
                                                {% endif %}
                                            </td>
                                            <td>
                                                {% if forloop.counter <= nb_articles %}
                                                    {% for document in codif_article.contents.all %}
                                                        {% with media=document.item %}
                                                           <p> {{ media.render }} </p>
                                                        {% endwith %}
                                                    {% endfor %}
                                                {% endif %}
                                            </td>
                                        </tr>
                                    {% endif %}
                                    <tr>
                                        <td class="text-right">Fabricant</td>
                                        <td>
                                                {{ form_codif_article.fabricant }}
                                                Réf Fab {{ form_codif_article.ref_fabricant }}
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Fournisseur</td>
                                        <td>
                                              {{ form_codif_article.fournisseur }}
                                              Réf Fourn {{ form_codif_article.ref_fournisseur }}
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Livraison souhaitée</td>
                                        <td class="danger">{{ form_codif_article.date_butoir }}</td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Demande de codification: {{ form_codif_article.demande_codification }} </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Demande d'approvisionnement <input id="id_codifarticle_related-{{ forloop.counter0 }}-demande_approvisionnement"
                                                   name="codifarticle_set-{{ forloop.counter0 }}-demande_approvisionnement"
                                                   {% if form_codif_article.demande_approvisionnement.value %}
                                                       checked="checked"
                                                   {% else %}
                                                   {% endif %}
                                                   data-toggle="collapse"
                                                   data-target="#demande_approvisionnement_{{ forloop.counter0 }}"
                                                   type="checkbox"
                                            />
                                        <td>
                                            <div id="demande_approvisionnement_{{ forloop.counter0 }}"
                                                   {% if form_codif_article.demande_approvisionnement.value %}
                                                   class="collapse in"
                                                   {% else %}
                                                   class="collapse"
                                                   {% endif %}
                                                   >
                                                <p>Besoin réel:  {{ form_codif_article.besoin_reel }}  Besoin potentiel: {{ form_codif_article.besoin_potentiel }}</p>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Demande de sortie du stock  <input  id="id_codifarticle_related-{{ forloop.counter0 }}-demande_sortie_stock"
                                                    name="codifarticle_set-{{ forloop.counter0 }}-demande_sortie_stock"
                                                    {% if form_codif_article.demande_sortie_stock.value %}
                                                        checked="checked"
                                                    {% else %}
                                                    {% endif %}
                                                    data-toggle="collapse"
                                                    data-target="#demande_sortie_stock_{{ forloop.counter0 }}"
                                                    type="checkbox"
                                            />
                                        </td>
                                        <td>
                                            <div id="demande_sortie_stock_{{ forloop.counter0 }}"
                                                 {% if form_codif_article.demande_sortie_stock.value %}
                                                 class="collapse in"
                                                 {% else %}
                                                 class="collapse"
                                                 {% endif %}
                                                 >
                                                Quantité à sortir: {{ form_codif_article.sortie_stock }}
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td class="text-right">Demande de cotation <input id="id_codifarticle_related-{{ forloop.counter0 }}-demande_cotation"
                                                    name="codifarticle_set-{{ forloop.counter0 }}-demande_cotation"
                                                    {% if form_codif_article.demande_cotation.value %}
                                                    checked="checked"
                                                    {% else %}
                                                    {% endif %}
                                                    data-toggle="collapse"
                                                    data-target="#demande_cotation_{{ forloop.counter0 }}"
                                                    type="checkbox"
                                            />
                                        </td>
                                        <td>

                                            <div id="demande_cotation_{{ forloop.counter0 }}"
                                                 {% if form_codif_article.demande_cotation.value %}
                                                 class="collapse in"
                                                 {% else %}
                                                 class="collapse"
                                                 {% endif %}
                                                 >
                                                Cotation par: {{ form_codif_article.cotation_par }}
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td colspan=2>
                                        {% if demande_article.demande_non_cloturee %}
                                        {% endif %}
                                        </td>
                                    </tr>
                                </tbody>
                            {# table imbriquee = 1 enregistrement #}
                            </table>
                        </td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>
</form>



{% endblock %}


{% block footer %}

{% endblock footer %}
